#include <stdio.h>
#include <sys/timeb.h>
#include "TmyList.h"


#define DoCallSort(sortType, sortName)			{									\
	struct _timeb startTime, endTime;										\
	long sTimeMS, eTimeMS;	/* start and end time in milli seconds */ 		\
	/* copy to useList to make sure       */								\
	/* we have original input for other types of */							\
	/* sorting.									 */							\
	useList.resetList();													\
	useList.duplicateList(inputList);										\
	_ftime(&startTime);														\
	useList.##sortType##();													\
	_ftime(&endTime);														\
	useList.sortedListCheck();												\
	useList.printListContent(sortName, printResults);						\
	sTimeMS = (startTime.time * 1000) + startTime.millitm;					\
	eTimeMS = (endTime.time * 1000) + endTime.millitm;						\
	/* fprintf(stdout, "Start(%d %d %d) End(%d %d %d)\n",   */				\
	/*		startTime.time, startTime.millitm, sTimeMS,     */				\
	/*			endTime.time, endTime.millitm, eTimeMS);    */				\
	fprintf(stdout, "Elapsed Time for %15s of %7d Elements: %7d mSec\n\n\n",\
					sortName, count, eTimeMS - sTimeMS);					\
}


int main(int argc, char *argv) {

	TmyList inputList, useList;
	int 	count, inputNum;
	bool 	printResults = false;

	if (argc > 1)
		printResults = true;

	scanf("%d", &count);
	
	for (int i=0; i<count; i++) {
		scanf("%d", &inputNum);
		inputList.insertElement(inputNum);
	}

	fprintf(stdout, "\n\n");
	useList.duplicateList(inputList);
	// useList.printListContent("useList Before Sort", printResults);

	DoCallSort(mergeSort, "mergeSort");
	// DoCallSort(insertionSort, "insertionSort");

	return 0;
}
